
set echo on

CREATE TYPE trade_ot UNDER transaction_ot
( product_type     VARCHAR2(10)
, counterparty     VARCHAR2(30)
, trade_timestamp  TIMESTAMP
, trading_book     VARCHAR2(30)
, maturity_date    DATE
, CONSTRUCTOR FUNCTION trade_ot 
     RETURN SELF AS RESULT
)
FINAL;
/

CREATE TYPE BODY trade_ot AS
   CONSTRUCTOR FUNCTION trade_ot 
      RETURN SELF AS RESULT IS
   BEGIN
      RETURN;
   END;
END;
/


CREATE TYPE trade_leg_ot UNDER transaction_ot
( leg_no             NUMBER
, trade_amount       NUMBER
, currency           VARCHAR2(3)
, trade_price        NUMBER
, CONSTRUCTOR FUNCTION trade_leg_ot 
     RETURN SELF AS RESULT
)
FINAL;
/

CREATE TYPE BODY trade_leg_ot AS
   CONSTRUCTOR FUNCTION trade_leg_ot
      RETURN SELF AS RESULT IS
   BEGIN
      RETURN;
   END;
END;
/

CREATE TYPE leg_valuation_ot UNDER transaction_ot
( leg_no           NUMBER
, valuation_date   DATE
, market_value     NUMBER
, CONSTRUCTOR FUNCTION leg_valuation_ot 
     RETURN SELF AS RESULT
)
FINAL;
/

CREATE TYPE BODY leg_valuation_ot AS
   CONSTRUCTOR FUNCTION leg_valuation_ot 
      RETURN SELF AS RESULT IS
   BEGIN
      RETURN;
   END;
END;
/

