
set echo on
set serveroutput on

ALTER SESSION ENABLE PARALLEL QUERY;
ALTER SESSION ENABLE PARALLEL DML;

ALTER TABLE trade_legs DISABLE CONSTRAINT trade_legs_fk01;
ALTER TABLE leg_valuations DISABLE CONSTRAINT leg_valuations_fk01;

exec trades_load.load_trades;

COMMIT;

SELECT COUNT(*) FROM trades;
SELECT COUNT(*) FROM trade_legs;
SELECT COUNT(*) FROM leg_valuations;

ALTER TABLE trade_legs ENABLE CONSTRAINT trade_legs_fk01;
ALTER TABLE leg_valuations ENABLE CONSTRAINT leg_valuations_fk01;


